from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    storages_count, paths_count, security_count = map(int, input().split())

    storages = [False] * storages_count
    paths = [[] for i in range(storages_count)]
    security = [0] * storages_count

    for i in range(paths_count):
        first, second = map(int, input().split())
        paths[first - 1].append(second - 1)
        paths[second - 1].append(first - 1)

    for i in range(security_count):
        location, power = map(int, input().split())
        security[location - 1] = power

    def check_cell(location, power, ignore_location=-1, ignore_security=False):
        if not storages[location]:
            if not ignore_security and security[location] != 0:
                if security[location] <= power:
                    security[location] = 0
                else:
                    return

            storages[location] = True

            able_paths = paths[location]
            if power > 0:
                for able_location in able_paths:
                    if able_location != ignore_location:
                        check_cell(able_location, power - 1, ignore_location)

    for i in range(len(security)):
        power = security[i]
        if power != 0:
            check_cell(i, power, ignore_security=True)

    print(storages.count(True))
    print(' '.join([str(i + 1) for i in range(len(storages)) if storages[i]]))


thread = threading.Thread(target=main)
thread.start()
