import math

n = int(input())

dots = [0] * n
angles = [0] * (math.factorial(n) // 2)

for i in range(n):
    x, y = map(int, input().split())
    dots[i] = [x, y]


angles_i = 0
for i in range(n - 1):
    start_pos = dots[i]
    for j in range(i + 1, n):
        end_pos = dots[j]
        value = (math.atan2(end_pos[1] - start_pos[1], end_pos[0] - start_pos[0]) + math.pi * 3 / 2) % math.pi - math.pi / 2
        angles[angles_i] = [value, i, j]
        angles_i += 1

famous = {}
for angles_i in range(len(angles)):
    if angles[angles_i] == 0: continue
    angle = (angles[angles_i][0] + math.pi / 2) % (math.pi / 2)
    famous[angle] = famous.get(angle, []) + [angles_i]

min_all_path = 1e10
for angle in sorted(famous, reverse=True, key=lambda a: len(famous[a])):
    all_path = 0
    mapping = [[] for _ in range(n)]
    angles_i = famous[angle]
    for angle_i in angles_i:
        _angle = angles[angle_i]
        mapping[_angle[1]].append(_angle[2])
        mapping[_angle[2]].append(_angle[1])
    for start_dot in range(len(mapping)):
        if len(mapping[start_dot]) <= 0:
            min_path = 1e10
            for dot in range(len(dots)):
                if dot != start_dot:
                    start_dot_p = dots[start_dot]
                    end_dot_p = dots[dot]
                    dx = end_dot_p[0] - start_dot_p[0]
                    dy = end_dot_p[1] - start_dot_p[1]
                    dx *= math.cos(angle)
                    dy *= math.sin(angle)
                    min_path = min(min_path, math.sqrt(dx**2 + dy**2))
            all_path += min_path
        else:
            for end_dot in mapping[start_dot]:
                start_dot_p = dots[start_dot]
                end_dot_p = dots[end_dot]
                all_path += math.sqrt((end_dot_p[0] - start_dot_p[0])**2 + (end_dot_p[1] - start_dot_p[1])**2)

    min_all_path = min(min_all_path, all_path)

print(min_all_path)
